﻿using KTour.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WinRTDatabase;

namespace KTour.ViewModels
{
    public class DatabaseViewModel : KTour.Common.BindableBase
    {
        private string DatabaseName = "KTourDb";
        private Database _database;

        /// <summary>
        /// 코드 마스터
        /// </summary>
        public Table<CodeModel> CodeMST { get; set; }

        public DatabaseViewModel()
        {
            if (Windows.ApplicationModel.DesignMode.DesignModeEnabled)
            {
                //디자인 타임
            }
            else
            { 
                //런타임
                Initialise();
            }
        }

        public async void Initialise()
        {
            var exists = await Database.DoesDatabaseExistsAsync(DatabaseName, StorageLocation.Local);
            if (!exists)
            {
                _database = await Database.CreateDatabaseAsync(DatabaseName, StorageLocation.Local);
                _database.CreateTable<CodeModel>();
                await _database.SaveAsync();
            }
            else
            {
                _database = await Database.OpenDatabaseAsync(DatabaseName, true, StorageLocation.Local);
            }

            CodeMST = await _database.Table<CodeModel>();
            //test();
        }

        private async void test()
        {
            CodeMST.Add(new CodeModel{ Code="1", Name = "서울", ValueInt = 1});
            CodeMST.Add(new CodeModel{ Code="2", Name = "인천", ValueInt = 2});
            CodeMST.Add(new CodeModel{ Code="3", Name = "대전", ValueInt = 3});
            CodeMST.Add(new CodeModel{ Code="4", Name = "대구", ValueInt = 4});
            CodeMST.Add(new CodeModel{ Code="5", Name = "광주", ValueInt = 5});
            await _database.SaveAsync();
        }

    }
}
